#include <iostream>
#include "graph.h"
#include "search.h"
using namespace std;

int main()
{
	Graph		g;
	NodeAttribute< int >	node2id;
	vector<Node>	id2node;
	int		i;

	for (i=0; i<=9; ++i)
	{
		id2node.push_back(g.CreateNode());
		node2id[id2node.back()] = i;
	}
	g.CreateEdge(id2node[6], id2node[1]);
	g.CreateEdge(id2node[1], id2node[4]);
	g.CreateEdge(id2node[3], id2node[4]);
	g.CreateEdge(id2node[8], id2node[9]);
	g.CreateEdge(id2node[2], id2node[5]);
	g.CreateEdge(id2node[2], id2node[3]);
	g.CreateEdge(id2node[5], id2node[1]);
	g.CreateEdge(id2node[2], id2node[8]);
	g.CreateEdge(id2node[9], id2node[0]);

	Edge e;
	cout << "Edges:" << endl;
	for (e=g.FirstEdge(); e; e=e.NextEdge())
		cout << "(" << node2id[e.SourceNode()] << "," << node2id[e.TargetNode()] << ")" << endl;


	GraphSearch s;
	cout << "DFS:" << endl;
	for(s.startDFS(g); !s.done(); s.Next())
		cout << "visiting node " << node2id[s.n] << endl;

	cout << "DFSPost:" << endl;
	for(s.startDFSPost(g); !s.done(); s.Next())
		cout << "visiting node " << node2id[s.n] << endl;

	cout << "Done" << endl;
	return 0;
}

